#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 105
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 63
#define ALIAS_COUNT 0
#define TOKEN_COUNT 28
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 5

enum ts_symbol_identifiers {
  anon_sym_type = 1,
  anon_sym_LBRACE = 2,
  anon_sym_RBRACE = 3,
  anon_sym_SEMI = 4,
  anon_sym_enum = 5,
  anon_sym_COMMA = 6,
  anon_sym_EQ = 7,
  anon_sym_define = 8,
  anon_sym_import = 9,
  anon_sym_service = 10,
  anon_sym_AT = 11,
  anon_sym_LPAREN = 12,
  anon_sym_RPAREN = 13,
  anon_sym_notification = 14,
  anon_sym_COLON = 15,
  anon_sym_QMARK = 16,
  anon_sym_int = 17,
  anon_sym_string = 18,
  anon_sym_float = 19,
  anon_sym_boolean = 20,
  anon_sym_void = 21,
  anon_sym_LBRACK_RBRACK = 22,
  sym_identifier = 23,
  anon_sym_DQUOTE = 24,
  sym_string_content = 25,
  sym_escape_sequence = 26,
  sym_number = 27,
  sym_document = 28,
  sym__statement = 29,
  sym_type_declaration = 30,
  sym_attributes = 31,
  sym_attribute = 32,
  sym_enum_declaration = 33,
  sym_enum_values = 34,
  sym_enum_value = 35,
  sym_enum_value_assignment = 36,
  sym_enum_value_declaration = 37,
  sym_define_declaration = 38,
  sym_import_declaration = 39,
  sym_service_declaration = 40,
  sym_service_functions = 41,
  sym_function_decorator = 42,
  sym_decorator_arguments = 43,
  sym_service_notification = 44,
  sym_service_function = 45,
  sym_function_arguments = 46,
  sym_function_argument = 47,
  sym_pair = 48,
  sym_type = 49,
  sym_primitive_type = 50,
  sym_array_type = 51,
  sym_map_type = 52,
  sym_map_key_type = 53,
  sym_string = 54,
  aux_sym__string_content = 55,
  aux_sym_document_repeat1 = 56,
  aux_sym_attributes_repeat1 = 57,
  aux_sym_enum_values_repeat1 = 58,
  aux_sym_service_functions_repeat1 = 59,
  aux_sym_service_functions_repeat2 = 60,
  aux_sym_decorator_arguments_repeat1 = 61,
  aux_sym_function_arguments_repeat1 = 62,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_type] = "type",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SEMI] = ";",
  [anon_sym_enum] = "enum",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_define] = "define",
  [anon_sym_import] = "import",
  [anon_sym_service] = "service",
  [anon_sym_AT] = "@",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_notification] = "notification",
  [anon_sym_COLON] = ":",
  [anon_sym_QMARK] = "\?",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [anon_sym_float] = "float",
  [anon_sym_boolean] = "boolean",
  [anon_sym_void] = "void",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [sym_identifier] = "identifier",
  [anon_sym_DQUOTE] = "\"",
  [sym_string_content] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_number] = "number",
  [sym_document] = "document",
  [sym__statement] = "_statement",
  [sym_type_declaration] = "type_declaration",
  [sym_attributes] = "attributes",
  [sym_attribute] = "attribute",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_values] = "enum_values",
  [sym_enum_value] = "enum_value",
  [sym_enum_value_assignment] = "enum_value_assignment",
  [sym_enum_value_declaration] = "enum_value_declaration",
  [sym_define_declaration] = "define_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_service_declaration] = "service_declaration",
  [sym_service_functions] = "service_functions",
  [sym_function_decorator] = "function_decorator",
  [sym_decorator_arguments] = "decorator_arguments",
  [sym_service_notification] = "service_notification",
  [sym_service_function] = "service_function",
  [sym_function_arguments] = "function_arguments",
  [sym_function_argument] = "function_argument",
  [sym_pair] = "pair",
  [sym_type] = "type",
  [sym_primitive_type] = "primitive_type",
  [sym_array_type] = "array_type",
  [sym_map_type] = "map_type",
  [sym_map_key_type] = "map_key_type",
  [sym_string] = "string",
  [aux_sym__string_content] = "_string_content",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym_enum_values_repeat1] = "enum_values_repeat1",
  [aux_sym_service_functions_repeat1] = "service_functions_repeat1",
  [aux_sym_service_functions_repeat2] = "service_functions_repeat2",
  [aux_sym_decorator_arguments_repeat1] = "decorator_arguments_repeat1",
  [aux_sym_function_arguments_repeat1] = "function_arguments_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_service] = anon_sym_service,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_notification] = anon_sym_notification,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [sym_identifier] = sym_identifier,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_string_content] = sym_string_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_number] = sym_number,
  [sym_document] = sym_document,
  [sym__statement] = sym__statement,
  [sym_type_declaration] = sym_type_declaration,
  [sym_attributes] = sym_attributes,
  [sym_attribute] = sym_attribute,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_values] = sym_enum_values,
  [sym_enum_value] = sym_enum_value,
  [sym_enum_value_assignment] = sym_enum_value_assignment,
  [sym_enum_value_declaration] = sym_enum_value_declaration,
  [sym_define_declaration] = sym_define_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_service_declaration] = sym_service_declaration,
  [sym_service_functions] = sym_service_functions,
  [sym_function_decorator] = sym_function_decorator,
  [sym_decorator_arguments] = sym_decorator_arguments,
  [sym_service_notification] = sym_service_notification,
  [sym_service_function] = sym_service_function,
  [sym_function_arguments] = sym_function_arguments,
  [sym_function_argument] = sym_function_argument,
  [sym_pair] = sym_pair,
  [sym_type] = sym_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_array_type] = sym_array_type,
  [sym_map_type] = sym_map_type,
  [sym_map_key_type] = sym_map_key_type,
  [sym_string] = sym_string,
  [aux_sym__string_content] = aux_sym__string_content,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym_enum_values_repeat1] = aux_sym_enum_values_repeat1,
  [aux_sym_service_functions_repeat1] = aux_sym_service_functions_repeat1,
  [aux_sym_service_functions_repeat2] = aux_sym_service_functions_repeat2,
  [aux_sym_decorator_arguments_repeat1] = aux_sym_decorator_arguments_repeat1,
  [aux_sym_function_arguments_repeat1] = aux_sym_function_arguments_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_service] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notification] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_values] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_value] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_value_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_value_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_define_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_service_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_service_functions] = {
    .visible = true,
    .named = true,
  },
  [sym_function_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_service_notification] = {
    .visible = true,
    .named = true,
  },
  [sym_service_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_function_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_map_key_type] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_service_functions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_service_functions_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorator_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_key = 1,
  field_name = 2,
  field_parameters = 3,
  field_return_type = 4,
  field_value = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_key] = "key",
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 2},
  [3] = {.index = 4, .length = 2},
  [4] = {.index = 6, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_key, 0},
    {field_value, 2},
  [2] =
    {field_key, 0},
    {field_value, 3},
  [4] =
    {field_name, 1},
    {field_parameters, 2},
  [6] =
    {field_name, 0},
    {field_parameters, 1},
    {field_return_type, 3},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '"', 121,
        '(', 72,
        ')', 73,
        ',', 66,
        ':', 76,
        ';', 64,
        '=', 67,
        '?', 77,
        '@', 71,
        '[', 5,
        '\\', 58,
        'b', 43,
        'd', 13,
        'e', 33,
        'f', 30,
        'i', 31,
        'n', 41,
        's', 14,
        't', 57,
        'v', 38,
        '{', 62,
        '}', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(3);
      if (lookahead == '"') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(58);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(122);
      if (lookahead != 0) ADVANCE(123);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(121);
      if (lookahead == ')') ADVANCE(73);
      if (lookahead == '}') ADVANCE(63);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(121);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      END_STATE();
    case 4:
      if (lookahead == '@') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(113);
      if (lookahead == '}') ADVANCE(63);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 5:
      if (lookahead == ']') ADVANCE(88);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(51);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(35);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 9:
      if (lookahead == 'b') ADVANCE(111);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 's') ADVANCE(115);
      if (lookahead == 'v') ADVANCE(108);
      if (lookahead == '{') ADVANCE(62);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(17);
      END_STATE();
    case 11:
      if (lookahead == 'c') ADVANCE(8);
      END_STATE();
    case 12:
      if (lookahead == 'd') ADVANCE(86);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(19);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(7);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(24);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(25);
      END_STATE();
    case 21:
      if (lookahead == 'g') ADVANCE(80);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(12);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(10);
      END_STATE();
    case 24:
      if (lookahead == 'i') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(11);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(34);
      END_STATE();
    case 27:
      if (lookahead == 'i') ADVANCE(44);
      END_STATE();
    case 28:
      if (lookahead == 'i') ADVANCE(20);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(18);
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 31:
      if (lookahead == 'm') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(6);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(15);
      END_STATE();
    case 46:
      if (lookahead == 'p') ADVANCE(42);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(56);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(28);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(27);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 56:
      if (lookahead == 'v') ADVANCE(23);
      END_STATE();
    case 57:
      if (lookahead == 'y') ADVANCE(45);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '"', 124,
        '/', 124,
        '\\', 124,
        'b', 124,
        'f', 124,
        'n', 124,
        'r', 124,
        't', 124,
        'u', 124,
      );
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '"', 121,
        '(', 72,
        ')', 73,
        ',', 66,
        ':', 76,
        ';', 64,
        '=', 67,
        '?', 77,
        '@', 71,
        '[', 5,
        'b', 43,
        'd', 13,
        'e', 33,
        'f', 30,
        'i', 31,
        'n', 41,
        's', 14,
        't', 57,
        'v', 38,
        '{', 62,
        '}', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_define);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_service);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_notification);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_notification);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_int);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_string);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_boolean);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_void);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(122);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 0},
  [3] = {.lex_state = 0},
  [4] = {.lex_state = 9},
  [5] = {.lex_state = 9},
  [6] = {.lex_state = 9},
  [7] = {.lex_state = 9},
  [8] = {.lex_state = 9},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 4},
  [12] = {.lex_state = 0},
  [13] = {.lex_state = 4},
  [14] = {.lex_state = 0},
  [15] = {.lex_state = 0},
  [16] = {.lex_state = 0},
  [17] = {.lex_state = 0},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 0},
  [20] = {.lex_state = 0},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 0},
  [23] = {.lex_state = 0},
  [24] = {.lex_state = 0},
  [25] = {.lex_state = 0},
  [26] = {.lex_state = 0},
  [27] = {.lex_state = 4},
  [28] = {.lex_state = 2},
  [29] = {.lex_state = 2},
  [30] = {.lex_state = 2},
  [31] = {.lex_state = 2},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 1},
  [35] = {.lex_state = 1},
  [36] = {.lex_state = 1},
  [37] = {.lex_state = 2},
  [38] = {.lex_state = 4},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 4},
  [43] = {.lex_state = 4},
  [44] = {.lex_state = 2},
  [45] = {.lex_state = 0},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 4},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 0},
  [51] = {.lex_state = 0},
  [52] = {.lex_state = 4},
  [53] = {.lex_state = 0},
  [54] = {.lex_state = 2},
  [55] = {.lex_state = 0},
  [56] = {.lex_state = 4},
  [57] = {.lex_state = 2},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 0},
  [63] = {.lex_state = 4},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 2},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 0},
  [70] = {.lex_state = 0},
  [71] = {.lex_state = 0},
  [72] = {.lex_state = 0},
  [73] = {.lex_state = 0},
  [74] = {.lex_state = 0},
  [75] = {.lex_state = 0},
  [76] = {.lex_state = 0},
  [77] = {.lex_state = 0},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 0},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 2},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 2},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 2},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 2},
  [92] = {.lex_state = 0},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 2},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 2},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_service] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_notification] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(85),
    [sym__statement] = STATE(2),
    [sym_type_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_define_declaration] = STATE(2),
    [sym_import_declaration] = STATE(2),
    [sym_service_declaration] = STATE(2),
    [aux_sym_document_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_type] = ACTIONS(5),
    [anon_sym_enum] = ACTIONS(7),
    [anon_sym_define] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_service] = ACTIONS(13),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(5), 1,
      anon_sym_type,
    ACTIONS(7), 1,
      anon_sym_enum,
    ACTIONS(9), 1,
      anon_sym_define,
    ACTIONS(11), 1,
      anon_sym_import,
    ACTIONS(13), 1,
      anon_sym_service,
    ACTIONS(15), 1,
      ts_builtin_sym_end,
    STATE(3), 7,
      sym__statement,
      sym_type_declaration,
      sym_enum_declaration,
      sym_define_declaration,
      sym_import_declaration,
      sym_service_declaration,
      aux_sym_document_repeat1,
  [28] = 7,
    ACTIONS(17), 1,
      ts_builtin_sym_end,
    ACTIONS(19), 1,
      anon_sym_type,
    ACTIONS(22), 1,
      anon_sym_enum,
    ACTIONS(25), 1,
      anon_sym_define,
    ACTIONS(28), 1,
      anon_sym_import,
    ACTIONS(31), 1,
      anon_sym_service,
    STATE(3), 7,
      sym__statement,
      sym_type_declaration,
      sym_enum_declaration,
      sym_define_declaration,
      sym_import_declaration,
      sym_service_declaration,
      aux_sym_document_repeat1,
  [56] = 6,
    ACTIONS(34), 1,
      anon_sym_LBRACE,
    ACTIONS(38), 1,
      sym_identifier,
    STATE(32), 1,
      sym_primitive_type,
    STATE(92), 1,
      sym_type,
    STATE(39), 2,
      sym_array_type,
      sym_map_type,
    ACTIONS(36), 5,
      anon_sym_int,
      anon_sym_string,
      anon_sym_float,
      anon_sym_boolean,
      anon_sym_void,
  [80] = 6,
    ACTIONS(34), 1,
      anon_sym_LBRACE,
    ACTIONS(38), 1,
      sym_identifier,
    STATE(32), 1,
      sym_primitive_type,
    STATE(87), 1,
      sym_type,
    STATE(39), 2,
      sym_array_type,
      sym_map_type,
    ACTIONS(36), 5,
      anon_sym_int,
      anon_sym_string,
      anon_sym_float,
      anon_sym_boolean,
      anon_sym_void,
  [104] = 6,
    ACTIONS(34), 1,
      anon_sym_LBRACE,
    ACTIONS(38), 1,
      sym_identifier,
    STATE(32), 1,
      sym_primitive_type,
    STATE(100), 1,
      sym_type,
    STATE(39), 2,
      sym_array_type,
      sym_map_type,
    ACTIONS(36), 5,
      anon_sym_int,
      anon_sym_string,
      anon_sym_float,
      anon_sym_boolean,
      anon_sym_void,
  [128] = 6,
    ACTIONS(34), 1,
      anon_sym_LBRACE,
    ACTIONS(38), 1,
      sym_identifier,
    STATE(32), 1,
      sym_primitive_type,
    STATE(76), 1,
      sym_type,
    STATE(39), 2,
      sym_array_type,
      sym_map_type,
    ACTIONS(36), 5,
      anon_sym_int,
      anon_sym_string,
      anon_sym_float,
      anon_sym_boolean,
      anon_sym_void,
  [152] = 6,
    ACTIONS(34), 1,
      anon_sym_LBRACE,
    ACTIONS(38), 1,
      sym_identifier,
    STATE(32), 1,
      sym_primitive_type,
    STATE(90), 1,
      sym_type,
    STATE(39), 2,
      sym_array_type,
      sym_map_type,
    ACTIONS(36), 5,
      anon_sym_int,
      anon_sym_string,
      anon_sym_float,
      anon_sym_boolean,
      anon_sym_void,
  [176] = 6,
    ACTIONS(40), 1,
      anon_sym_RBRACE,
    ACTIONS(42), 1,
      anon_sym_AT,
    ACTIONS(44), 1,
      anon_sym_notification,
    ACTIONS(46), 1,
      sym_identifier,
    STATE(13), 2,
      sym_function_decorator,
      aux_sym_service_functions_repeat1,
    STATE(10), 3,
      sym_service_notification,
      sym_service_function,
      aux_sym_service_functions_repeat2,
  [198] = 6,
    ACTIONS(48), 1,
      anon_sym_RBRACE,
    ACTIONS(50), 1,
      anon_sym_AT,
    ACTIONS(53), 1,
      anon_sym_notification,
    ACTIONS(56), 1,
      sym_identifier,
    STATE(13), 2,
      sym_function_decorator,
      aux_sym_service_functions_repeat1,
    STATE(10), 3,
      sym_service_notification,
      sym_service_function,
      aux_sym_service_functions_repeat2,
  [220] = 6,
    ACTIONS(42), 1,
      anon_sym_AT,
    ACTIONS(44), 1,
      anon_sym_notification,
    ACTIONS(46), 1,
      sym_identifier,
    ACTIONS(59), 1,
      anon_sym_RBRACE,
    STATE(13), 2,
      sym_function_decorator,
      aux_sym_service_functions_repeat1,
    STATE(9), 3,
      sym_service_notification,
      sym_service_function,
      aux_sym_service_functions_repeat2,
  [242] = 3,
    ACTIONS(63), 1,
      anon_sym_LBRACE,
    STATE(16), 1,
      sym_attributes,
    ACTIONS(61), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [257] = 5,
    ACTIONS(42), 1,
      anon_sym_AT,
    ACTIONS(44), 1,
      anon_sym_notification,
    ACTIONS(46), 1,
      sym_identifier,
    STATE(27), 2,
      sym_function_decorator,
      aux_sym_service_functions_repeat1,
    STATE(38), 2,
      sym_service_notification,
      sym_service_function,
  [275] = 1,
    ACTIONS(65), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [284] = 1,
    ACTIONS(67), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [293] = 1,
    ACTIONS(69), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [302] = 1,
    ACTIONS(71), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [311] = 1,
    ACTIONS(73), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [320] = 1,
    ACTIONS(75), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [329] = 1,
    ACTIONS(77), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [338] = 1,
    ACTIONS(79), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [347] = 1,
    ACTIONS(81), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [356] = 1,
    ACTIONS(83), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [365] = 1,
    ACTIONS(85), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [374] = 1,
    ACTIONS(87), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [383] = 1,
    ACTIONS(89), 6,
      ts_builtin_sym_end,
      anon_sym_type,
      anon_sym_enum,
      anon_sym_define,
      anon_sym_import,
      anon_sym_service,
  [392] = 3,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(94), 2,
      anon_sym_notification,
      sym_identifier,
    STATE(27), 2,
      sym_function_decorator,
      aux_sym_service_functions_repeat1,
  [404] = 4,
    ACTIONS(96), 1,
      anon_sym_RBRACE,
    ACTIONS(98), 1,
      sym_identifier,
    STATE(102), 1,
      sym_pair,
    STATE(28), 2,
      sym_attribute,
      aux_sym_attributes_repeat1,
  [418] = 4,
    ACTIONS(101), 1,
      anon_sym_RBRACE,
    ACTIONS(103), 1,
      sym_identifier,
    STATE(61), 1,
      sym_enum_value,
    STATE(75), 2,
      sym_enum_value_assignment,
      sym_enum_value_declaration,
  [432] = 4,
    ACTIONS(105), 1,
      anon_sym_RBRACE,
    ACTIONS(107), 1,
      sym_identifier,
    STATE(102), 1,
      sym_pair,
    STATE(28), 2,
      sym_attribute,
      aux_sym_attributes_repeat1,
  [446] = 4,
    ACTIONS(107), 1,
      sym_identifier,
    ACTIONS(109), 1,
      anon_sym_RBRACE,
    STATE(102), 1,
      sym_pair,
    STATE(30), 2,
      sym_attribute,
      aux_sym_attributes_repeat1,
  [460] = 2,
    ACTIONS(113), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(111), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [470] = 1,
    ACTIONS(115), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [478] = 3,
    ACTIONS(117), 1,
      anon_sym_DQUOTE,
    STATE(36), 1,
      aux_sym__string_content,
    ACTIONS(119), 2,
      sym_string_content,
      sym_escape_sequence,
  [489] = 3,
    ACTIONS(121), 1,
      anon_sym_DQUOTE,
    STATE(34), 1,
      aux_sym__string_content,
    ACTIONS(123), 2,
      sym_string_content,
      sym_escape_sequence,
  [500] = 3,
    ACTIONS(125), 1,
      anon_sym_DQUOTE,
    STATE(36), 1,
      aux_sym__string_content,
    ACTIONS(127), 2,
      sym_string_content,
      sym_escape_sequence,
  [511] = 4,
    ACTIONS(107), 1,
      sym_identifier,
    ACTIONS(130), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_attribute,
    STATE(102), 1,
      sym_pair,
  [524] = 2,
    ACTIONS(48), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(132), 2,
      anon_sym_notification,
      sym_identifier,
  [533] = 1,
    ACTIONS(111), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [540] = 1,
    ACTIONS(134), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [547] = 1,
    ACTIONS(136), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [554] = 2,
    ACTIONS(138), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(140), 2,
      anon_sym_notification,
      sym_identifier,
  [563] = 2,
    ACTIONS(142), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(144), 2,
      anon_sym_notification,
      sym_identifier,
  [572] = 3,
    ACTIONS(103), 1,
      sym_identifier,
    STATE(72), 1,
      sym_enum_value,
    STATE(75), 2,
      sym_enum_value_assignment,
      sym_enum_value_declaration,
  [583] = 3,
    ACTIONS(146), 1,
      anon_sym_COMMA,
    ACTIONS(148), 1,
      anon_sym_RPAREN,
    STATE(53), 1,
      aux_sym_function_arguments_repeat1,
  [593] = 3,
    ACTIONS(150), 1,
      anon_sym_RPAREN,
    ACTIONS(152), 1,
      anon_sym_DQUOTE,
    STATE(55), 1,
      sym_string,
  [603] = 3,
    ACTIONS(154), 1,
      anon_sym_COMMA,
    ACTIONS(157), 1,
      anon_sym_RPAREN,
    STATE(47), 1,
      aux_sym_decorator_arguments_repeat1,
  [613] = 2,
    ACTIONS(159), 1,
      anon_sym_AT,
    ACTIONS(161), 2,
      anon_sym_notification,
      sym_identifier,
  [621] = 3,
    ACTIONS(163), 1,
      anon_sym_COMMA,
    ACTIONS(166), 1,
      anon_sym_RPAREN,
    STATE(49), 1,
      aux_sym_function_arguments_repeat1,
  [631] = 3,
    ACTIONS(168), 1,
      anon_sym_COMMA,
    ACTIONS(170), 1,
      anon_sym_RPAREN,
    STATE(47), 1,
      aux_sym_decorator_arguments_repeat1,
  [641] = 3,
    ACTIONS(172), 1,
      anon_sym_RBRACE,
    ACTIONS(174), 1,
      anon_sym_COMMA,
    STATE(64), 1,
      aux_sym_enum_values_repeat1,
  [651] = 2,
    ACTIONS(176), 1,
      anon_sym_AT,
    ACTIONS(178), 2,
      anon_sym_notification,
      sym_identifier,
  [659] = 3,
    ACTIONS(146), 1,
      anon_sym_COMMA,
    ACTIONS(180), 1,
      anon_sym_RPAREN,
    STATE(49), 1,
      aux_sym_function_arguments_repeat1,
  [669] = 3,
    ACTIONS(182), 1,
      anon_sym_RPAREN,
    ACTIONS(184), 1,
      sym_identifier,
    STATE(45), 1,
      sym_function_argument,
  [679] = 3,
    ACTIONS(168), 1,
      anon_sym_COMMA,
    ACTIONS(186), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_decorator_arguments_repeat1,
  [689] = 2,
    ACTIONS(188), 1,
      anon_sym_AT,
    ACTIONS(190), 2,
      anon_sym_notification,
      sym_identifier,
  [697] = 3,
    ACTIONS(152), 1,
      anon_sym_DQUOTE,
    ACTIONS(192), 1,
      sym_identifier,
    STATE(101), 1,
      sym_string,
  [707] = 1,
    ACTIONS(194), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [713] = 1,
    ACTIONS(196), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [719] = 2,
    STATE(93), 1,
      sym_map_key_type,
    ACTIONS(198), 2,
      anon_sym_int,
      anon_sym_string,
  [727] = 3,
    ACTIONS(174), 1,
      anon_sym_COMMA,
    ACTIONS(200), 1,
      anon_sym_RBRACE,
    STATE(51), 1,
      aux_sym_enum_values_repeat1,
  [737] = 2,
    ACTIONS(204), 1,
      anon_sym_EQ,
    ACTIONS(202), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [745] = 2,
    ACTIONS(206), 1,
      anon_sym_AT,
    ACTIONS(208), 2,
      anon_sym_notification,
      sym_identifier,
  [753] = 3,
    ACTIONS(210), 1,
      anon_sym_RBRACE,
    ACTIONS(212), 1,
      anon_sym_COMMA,
    STATE(64), 1,
      aux_sym_enum_values_repeat1,
  [763] = 1,
    ACTIONS(215), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [768] = 2,
    ACTIONS(184), 1,
      sym_identifier,
    STATE(74), 1,
      sym_function_argument,
  [775] = 1,
    ACTIONS(217), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [780] = 1,
    ACTIONS(157), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [785] = 2,
    ACTIONS(219), 1,
      anon_sym_COLON,
    ACTIONS(221), 1,
      anon_sym_QMARK,
  [792] = 1,
    ACTIONS(223), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [797] = 1,
    ACTIONS(225), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [802] = 1,
    ACTIONS(210), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [807] = 2,
    ACTIONS(227), 1,
      anon_sym_LBRACE,
    STATE(21), 1,
      sym_service_functions,
  [814] = 1,
    ACTIONS(166), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [819] = 1,
    ACTIONS(229), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [824] = 1,
    ACTIONS(231), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [829] = 2,
    ACTIONS(233), 1,
      anon_sym_LPAREN,
    STATE(63), 1,
      sym_decorator_arguments,
  [836] = 2,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    STATE(89), 1,
      sym_function_arguments,
  [843] = 2,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    STATE(97), 1,
      sym_function_arguments,
  [850] = 2,
    ACTIONS(152), 1,
      anon_sym_DQUOTE,
    STATE(68), 1,
      sym_string,
  [857] = 2,
    ACTIONS(237), 1,
      anon_sym_LBRACE,
    STATE(17), 1,
      sym_enum_values,
  [864] = 2,
    ACTIONS(152), 1,
      anon_sym_DQUOTE,
    STATE(95), 1,
      sym_string,
  [871] = 1,
    ACTIONS(239), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [876] = 1,
    ACTIONS(241), 1,
      sym_identifier,
  [880] = 1,
    ACTIONS(243), 1,
      ts_builtin_sym_end,
  [884] = 1,
    ACTIONS(245), 1,
      sym_identifier,
  [888] = 1,
    ACTIONS(247), 1,
      anon_sym_SEMI,
  [892] = 1,
    ACTIONS(249), 1,
      sym_identifier,
  [896] = 1,
    ACTIONS(251), 1,
      anon_sym_COLON,
  [900] = 1,
    ACTIONS(253), 1,
      anon_sym_SEMI,
  [904] = 1,
    ACTIONS(255), 1,
      sym_identifier,
  [908] = 1,
    ACTIONS(257), 1,
      anon_sym_SEMI,
  [912] = 1,
    ACTIONS(259), 1,
      anon_sym_COMMA,
  [916] = 1,
    ACTIONS(261), 1,
      anon_sym_COMMA,
  [920] = 1,
    ACTIONS(263), 1,
      anon_sym_SEMI,
  [924] = 1,
    ACTIONS(265), 1,
      anon_sym_COLON,
  [928] = 1,
    ACTIONS(267), 1,
      anon_sym_SEMI,
  [932] = 1,
    ACTIONS(269), 1,
      sym_number,
  [936] = 1,
    ACTIONS(271), 1,
      sym_identifier,
  [940] = 1,
    ACTIONS(273), 1,
      anon_sym_RBRACE,
  [944] = 1,
    ACTIONS(275), 1,
      anon_sym_SEMI,
  [948] = 1,
    ACTIONS(277), 1,
      anon_sym_SEMI,
  [952] = 1,
    ACTIONS(279), 1,
      anon_sym_COLON,
  [956] = 1,
    ACTIONS(281), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 28,
  [SMALL_STATE(4)] = 56,
  [SMALL_STATE(5)] = 80,
  [SMALL_STATE(6)] = 104,
  [SMALL_STATE(7)] = 128,
  [SMALL_STATE(8)] = 152,
  [SMALL_STATE(9)] = 176,
  [SMALL_STATE(10)] = 198,
  [SMALL_STATE(11)] = 220,
  [SMALL_STATE(12)] = 242,
  [SMALL_STATE(13)] = 257,
  [SMALL_STATE(14)] = 275,
  [SMALL_STATE(15)] = 284,
  [SMALL_STATE(16)] = 293,
  [SMALL_STATE(17)] = 302,
  [SMALL_STATE(18)] = 311,
  [SMALL_STATE(19)] = 320,
  [SMALL_STATE(20)] = 329,
  [SMALL_STATE(21)] = 338,
  [SMALL_STATE(22)] = 347,
  [SMALL_STATE(23)] = 356,
  [SMALL_STATE(24)] = 365,
  [SMALL_STATE(25)] = 374,
  [SMALL_STATE(26)] = 383,
  [SMALL_STATE(27)] = 392,
  [SMALL_STATE(28)] = 404,
  [SMALL_STATE(29)] = 418,
  [SMALL_STATE(30)] = 432,
  [SMALL_STATE(31)] = 446,
  [SMALL_STATE(32)] = 460,
  [SMALL_STATE(33)] = 470,
  [SMALL_STATE(34)] = 478,
  [SMALL_STATE(35)] = 489,
  [SMALL_STATE(36)] = 500,
  [SMALL_STATE(37)] = 511,
  [SMALL_STATE(38)] = 524,
  [SMALL_STATE(39)] = 533,
  [SMALL_STATE(40)] = 540,
  [SMALL_STATE(41)] = 547,
  [SMALL_STATE(42)] = 554,
  [SMALL_STATE(43)] = 563,
  [SMALL_STATE(44)] = 572,
  [SMALL_STATE(45)] = 583,
  [SMALL_STATE(46)] = 593,
  [SMALL_STATE(47)] = 603,
  [SMALL_STATE(48)] = 613,
  [SMALL_STATE(49)] = 621,
  [SMALL_STATE(50)] = 631,
  [SMALL_STATE(51)] = 641,
  [SMALL_STATE(52)] = 651,
  [SMALL_STATE(53)] = 659,
  [SMALL_STATE(54)] = 669,
  [SMALL_STATE(55)] = 679,
  [SMALL_STATE(56)] = 689,
  [SMALL_STATE(57)] = 697,
  [SMALL_STATE(58)] = 707,
  [SMALL_STATE(59)] = 713,
  [SMALL_STATE(60)] = 719,
  [SMALL_STATE(61)] = 727,
  [SMALL_STATE(62)] = 737,
  [SMALL_STATE(63)] = 745,
  [SMALL_STATE(64)] = 753,
  [SMALL_STATE(65)] = 763,
  [SMALL_STATE(66)] = 768,
  [SMALL_STATE(67)] = 775,
  [SMALL_STATE(68)] = 780,
  [SMALL_STATE(69)] = 785,
  [SMALL_STATE(70)] = 792,
  [SMALL_STATE(71)] = 797,
  [SMALL_STATE(72)] = 802,
  [SMALL_STATE(73)] = 807,
  [SMALL_STATE(74)] = 814,
  [SMALL_STATE(75)] = 819,
  [SMALL_STATE(76)] = 824,
  [SMALL_STATE(77)] = 829,
  [SMALL_STATE(78)] = 836,
  [SMALL_STATE(79)] = 843,
  [SMALL_STATE(80)] = 850,
  [SMALL_STATE(81)] = 857,
  [SMALL_STATE(82)] = 864,
  [SMALL_STATE(83)] = 871,
  [SMALL_STATE(84)] = 876,
  [SMALL_STATE(85)] = 880,
  [SMALL_STATE(86)] = 884,
  [SMALL_STATE(87)] = 888,
  [SMALL_STATE(88)] = 892,
  [SMALL_STATE(89)] = 896,
  [SMALL_STATE(90)] = 900,
  [SMALL_STATE(91)] = 904,
  [SMALL_STATE(92)] = 908,
  [SMALL_STATE(93)] = 912,
  [SMALL_STATE(94)] = 916,
  [SMALL_STATE(95)] = 920,
  [SMALL_STATE(96)] = 924,
  [SMALL_STATE(97)] = 928,
  [SMALL_STATE(98)] = 932,
  [SMALL_STATE(99)] = 936,
  [SMALL_STATE(100)] = 940,
  [SMALL_STATE(101)] = 944,
  [SMALL_STATE(102)] = 948,
  [SMALL_STATE(103)] = 952,
  [SMALL_STATE(104)] = 956,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0, 0, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [15] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1, 0, 0),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0),
  [19] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [22] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [25] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [28] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [31] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [34] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [36] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [38] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [40] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [42] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [44] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [46] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [48] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_service_functions_repeat2, 2, 0, 0),
  [50] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_service_functions_repeat2, 2, 0, 0), SHIFT_REPEAT(91),
  [53] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_service_functions_repeat2, 2, 0, 0), SHIFT_REPEAT(84),
  [56] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_service_functions_repeat2, 2, 0, 0), SHIFT_REPEAT(78),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2, 0, 0),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_service_functions, 3, 0, 0),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_values, 3, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3, 0, 0),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 4, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_values, 4, 0, 0),
  [77] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 0),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_service_declaration, 3, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 2, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_service_functions, 2, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_values, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 3, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define_declaration, 4, 0, 0),
  [91] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_service_functions_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [94] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_service_functions_repeat1, 2, 0, 0),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [98] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_content, 2, 0, 0),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_content, 2, 0, 0), SHIFT_REPEAT(36),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_service_functions_repeat2, 2, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, 0, 0),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0),
  [138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_service_notification, 4, 0, 3),
  [140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_service_notification, 4, 0, 3),
  [142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_service_function, 5, 0, 4),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_service_function, 5, 0, 4),
  [146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorator_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(80),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorator_arguments_repeat1, 2, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_arguments, 4, 0, 0),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_arguments, 4, 0, 0),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_arguments_repeat1, 2, 0, 0),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_arguments, 3, 0, 0),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_arguments, 3, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_arguments, 2, 0, 0),
  [190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_arguments, 2, 0, 0),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_value_declaration, 1, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_decorator, 3, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_decorator, 3, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_values_repeat1, 2, 0, 0),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_values_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 2, 0, 0),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 0),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 4, 0, 0),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_value_assignment, 3, 0, 0),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_value, 1, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 3, 0, 0),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 3, 0, 0),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [243] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 1),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 4, 0, 2),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_key_type, 1, 0, 0),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_jrpc(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
